diff -ruN ccp4srs-old/ccp4srs/ccp4srs_container.h ccp4srs/ccp4srs/ccp4srs_container.h
--- ccp4srs-old/ccp4srs/ccp4srs_container.h	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_container.h	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_container.h, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_container.h $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,16 +22,16 @@
 //
 //  =================================================================
 //
-//    29.04.10   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_container  <interface>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSContainer  - template container class
+//  **** Classes :  ccp4srs::Container  - template container class
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010
+//  (C) E. Krissinel 2010-2013
 //
 //  =================================================================
 //
@@ -41,96 +41,100 @@
 
 #include "memio_.h"
 
-template <class T>
+namespace ccp4srs  {
 
-class CCP4SRSContainer  {
+  template <class T>
 
-  protected:
-    int  n_objects;
-    T  **object;
-
-  private:
-    int  n_alloc;
-
-  public:
-
-    CCP4SRSContainer()  {
-      object    = NULL;
-      n_objects = 0;
-      n_alloc   = 0;
-    }
-
-    virtual ~CCP4SRSContainer()  {
-      empty();
-    }
-
-    void empty()  {
-    int i;
-      if (object)  {
-        for (i=0;i<n_alloc;i++)
-          if (object[i])  delete object[i];
-        delete[] object;
-        object = NULL;
-      }
-      n_objects = 0;
-      n_alloc   = 0;
-    }
-
-    inline int numberOf()      { return n_objects;   }
-    inline T*  at ( int pos )  { return object[pos]; }
-
-    int  index ( cpstr id )  {
-    int  i,k;
-      k = -1;
-      if (id)  {
-        for (i=0;(i<n_objects) && (k<0);i++)
-          if (!strcmp(id,object[i]->id()))  k = i;
-      }
-      return k;
-    }
-
-    void add ( T* obj )  {
-    T**  tobject;
-    int  i;
-      if (n_objects>=n_alloc)  {
-        n_alloc = n_objects+10;
-        tobject = new T*[n_alloc];
+  class Container  {
+
+    protected:
+      int  n_objects;
+      T  **object;
+
+    private:
+      int  n_alloc;
+
+    public:
+
+      Container()  {
+        object    = NULL;
+        n_objects = 0;
+        n_alloc   = 0;
+      }
+
+      virtual ~Container()  {
+        empty();
+      }
+
+      void empty()  {
+      int i;
+        if (object)  {
+          for (i=0;i<n_alloc;i++)
+            if (object[i])  delete object[i];
+          delete[] object;
+          object = NULL;
+        }
+        n_objects = 0;
+        n_alloc   = 0;
+      }
+
+      inline int numberOf()      { return n_objects;   }
+      inline T*  at ( int pos )  { return object[pos]; }
+
+      int  index ( mmdb::cpstr id )  {
+      int  i,k;
+        k = -1;
+        if (id)  {
+          for (i=0;(i<n_objects) && (k<0);i++)
+            if (!strcmp(id,object[i]->id()))  k = i;
+        }
+        return k;
+      }
+
+      void add ( T* obj )  {
+      T**  tobject;
+      int  i;
+        if (n_objects>=n_alloc)  {
+          n_alloc = n_objects+10;
+          tobject = new T*[n_alloc];
+          for (i=0;i<n_objects;i++)
+            tobject[i] = object[i];
+          for (i=n_objects;i<n_alloc;i++)
+            tobject[i] = NULL;
+          delete[] object;
+          object = tobject;
+        }
+        object[n_objects++] = obj;
+      }
+
+      void  write_mem ( PMemIO memIO, int version )  {
+      int i;
+        memIO->put_integer ( n_objects );
         for (i=0;i<n_objects;i++)
-          tobject[i] = object[i];
-        for (i=n_objects;i<n_alloc;i++)
-          tobject[i] = NULL;
-        delete[] object;
-        object = tobject;
-      }
-      object[n_objects++] = obj;
-    }
-
-    void  write_mem ( PCMemIO memIO, int version )  {
-    int i;
-      memIO->put_integer ( n_objects );
-      for (i=0;i<n_objects;i++)
-        object[i]->write_mem ( memIO,version );
-    }
-
-    Boolean read_mem ( PCMemIO memIO, int version, Boolean * Ok )  {
-    int     i;
-    Boolean success;
-      empty();
-      if (Ok)  success = *Ok;
-         else  success = True;
-      memIO->get_integer ( n_objects,&success );
-      n_alloc = n_objects;
-      if (n_objects>0)  {
-        object = new T*[n_alloc];
-        for (i=0;i<n_objects;i++)  {
-          object[i] = new T();
-          object[i]->read_mem ( memIO,version,&success );
+          object[i]->write_mem ( memIO,version );
+      }
+
+      bool read_mem ( PMemIO memIO, int version, bool * Ok )  {
+      int  i;
+      bool success;
+        empty();
+        if (Ok)  success = *Ok;
+           else  success = true;
+        memIO->get_integer ( n_objects,&success );
+        n_alloc = n_objects;
+        if (n_objects>0)  {
+          object = new T*[n_alloc];
+          for (i=0;i<n_objects;i++)  {
+            object[i] = new T();
+            object[i]->read_mem ( memIO,version,&success );
+          }
         }
+        if (Ok)  *Ok = success;
+        return success;
       }
-      if (Ok)  *Ok = success;
-      return success;
-    }
 
-};
+  };
+
+}  // namespace ccp4srs
 
 #endif // CCP4SRS_CONTAINER_H
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_defs.h ccp4srs/ccp4srs/ccp4srs_defs.h
--- ccp4srs-old/ccp4srs/ccp4srs_defs.h	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_defs.h	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_defs.h, v 1.00 2010/03/11 15:28:14 eugene Exp $
+//  $Id: ccp4srs_defs.h $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrievak and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010-2011.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,7 +22,7 @@
 //
 //  =================================================================
 //
-//    26.02.13   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
@@ -39,35 +39,8 @@
 #ifndef CCP4SRS_DEFS_H
 #define CCP4SRS_DEFS_H
 
-#define  CCP4SRS_file_version            2
-
-#define  CCP4SRS_noDonors               (4)
-#define  CCP4SRS_noAcceptors            (3)
-#define  CCP4SRS_noHBonds               (2)
-#define  CCP4SRS_Incomplete             (1)
-#define  CCP4SRS_Ok                     (0)
-#define  CCP4SRS_WrongBondType          (-1)
-#define  CCP4SRS_IndexCorrupt           (-2)
-#define  CCP4SRS_FileNotFound           (-3)
-#define  CCP4SRS_EntryNotFound          (-4)
-#define  CCP4SRS_ReadErrors             (-5)
-#define  CCP4SRS_EmptyResidue           (-6)
-#define  CCP4SRS_NoAtomsFound           (-7)
-#define  CCP4SRS_NoBonds                (-8)
-#define  CCP4SRS_EmptyResSet            (-9)
-#define  CCP4SRS_Fail                   (-10)
-#define  CCP4SRS_SVD_Fail               (-11)
-#define  CCP4SRS_noCoordHierarchy       (-12)
-#define  CCP4SRS_BrokenBonds            (-13)
-
-
-#define  srsIndexFile   "index.srs"
-#define  srsGraphFile   "graph.srs"
-#define  srsStructFile  "struct.srs"
-
-
-//  special atom ids
-#define CCP4SRSAtomID_NA             (-10000)
+// THIS FILE SHOULD BE NEVER UNCLUDED IN HEADERS. USE CCP4SRS_TYPES.H
+// INSTEAD
 
 //  mmCIF tags
 #define MMCIF_COMP                   "comp_"
@@ -129,6 +102,11 @@
 #define MMCIF_TAG_PLANE_ID               "plane_id"
 #define MMCIF_TAG_DIST_ESD               "dist_esd"
 
+#define MMCIF_LOOP_CHEM_COMP_DESCRIPTOR  "_pdbx_chem_comp_descriptor"
+#define MMCIF_TAG_PROGRAM                "program"
+#define MMCIF_TAG_PROGRAM_VERSION        "program_version"
+#define MMCIF_TAG_DESCRIPTOR             "descriptor"
+
 
 //   Entry types
 /*
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_entry.cpp ccp4srs/ccp4srs/ccp4srs_entry.cpp
--- ccp4srs-old/ccp4srs/ccp4srs_entry.cpp	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_entry.cpp	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_entry.cpp, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_entry.cpp $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,16 +22,16 @@
 //
 //  =================================================================
 //
-//    11.03.10   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_entry  <implementation>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSEntry  - base class for all SRS entries
+//  **** Classes :  ccp4srs::Entry  - base class for all SRS entries
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010
+//  (C) E. Krissinel 2010-2013
 //
 //  =================================================================
 //
@@ -39,56 +39,60 @@
 #include "ccp4srs_entry.h"
 #include "ccp4srs_defs.h"
 
-CCP4SRSEntry::CCP4SRSEntry()  {}
+namespace ccp4srs  {
 
-CCP4SRSEntry::~CCP4SRSEntry() {}
+  Entry::Entry()  {}
 
-int CCP4SRSEntry::write ( RCFile f, int version, PCMemIO memIO ) {
-PCMemIO mem_io;
-int     rc;
+  Entry::~Entry() {}
 
-  if (memIO)  mem_io = memIO;
-        else  mem_io = new CMemIO();
+  int Entry::write ( mmdb::io::RFile f, int version, PMemIO memIO ) {
+  PMemIO mem_io;
+  int    rc;
 
-  write_mem ( mem_io,version );
-  rc = mem_io->write ( f );
+    if (memIO)  mem_io = memIO;
+          else  mem_io = new MemIO();
 
-  if (!memIO)
-    delete mem_io;
+    write_mem ( mem_io,version );
+    rc = mem_io->write ( f );
 
-  return rc;
+    if (!memIO)
+      delete mem_io;
 
-}
+    return rc;
 
-int CCP4SRSEntry::read ( RCFile f, int version, PCMemIO memIO )  {
-PCMemIO mem_io;
-int     rc;
+  }
+
+  int Entry::read ( mmdb::io::RFile f, int version, PMemIO memIO )  {
+  PMemIO mem_io;
+  int    rc;
+
+    if (memIO)  mem_io = memIO;
+          else  mem_io = new MemIO();
+
+    rc = mem_io->read ( f );
+    if (rc==MemIO::Ok)  {
+      if (!read_mem(mem_io,version))
+        rc = MemIO::MemReadError;
+    }
+
+    if (!memIO)
+      delete mem_io;
 
-  if (memIO)  mem_io = memIO;
-        else  mem_io = new CMemIO();
+    return rc;
 
-  rc = mem_io->read ( f );
-  if (rc==CMemIO::Ok)  {
-    if (!read_mem(mem_io,version))
-      rc = CMemIO::MemReadError;
   }
 
-  if (!memIO)
-    delete mem_io;
+  void Entry::write_mem ( PMemIO memIO, int version )  {
+  UNUSED_ARGUMENT(memIO);
+  UNUSED_ARGUMENT(version);
+  }
 
-  return rc;
+  bool Entry::read_mem ( PMemIO memIO, int version, bool * Ok )  {
+  UNUSED_ARGUMENT(memIO);
+  UNUSED_ARGUMENT(version);
+  UNUSED_ARGUMENT(Ok);
+    return true;
+  }
 
-}
+}  // namespace ccp4srs
 
-void CCP4SRSEntry::write_mem ( PCMemIO memIO, int version )  {
-UNUSED_ARGUMENT(memIO);
-UNUSED_ARGUMENT(version);
-}
-
-Boolean CCP4SRSEntry::read_mem ( PCMemIO memIO, int version,
-                                 Boolean * Ok )  {
-UNUSED_ARGUMENT(memIO);
-UNUSED_ARGUMENT(version);
-UNUSED_ARGUMENT(Ok);
-  return True;
-}
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_entry.h ccp4srs/ccp4srs/ccp4srs_entry.h
--- ccp4srs-old/ccp4srs/ccp4srs_entry.h	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_entry.h	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_entry.h, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_entry.h $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,16 +22,16 @@
 //
 //  =================================================================
 //
-//    11.03.10   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_entry  <interface>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSEntry  - base class for all SRS entries
+//  **** Classes :  ccp4srs::Entry  - base class for all SRS entries
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010
+//  (C) E. Krissinel 2010-2013
 //
 //  =================================================================
 //
@@ -41,29 +41,34 @@
 
 #include "memio_.h"
 
-DefineClass(CCP4SRSEntry)
+namespace ccp4srs  {
 
-class CCP4SRSEntry  {
+  DefineClass(Entry);
 
-  public:
+  class Entry  {
 
-    // entry types
-    enum {None,Monomer,Link};
+    public:
 
-    CCP4SRSEntry();
-    virtual ~CCP4SRSEntry();
+      // entry types
+      enum {None,Monomer,Link};
 
-    virtual int type()  { return CCP4SRSEntry::None; }
+      Entry();
+      virtual ~Entry();
 
-    int write ( RCFile f, int version, PCMemIO memIO=NULL );
-    int read  ( RCFile f, int version, PCMemIO memIO=NULL );
+      virtual int type()  { return Entry::None; }
 
-  protected:
+      int write ( mmdb::io::RFile f, int version, PMemIO memIO=NULL );
+      int read  ( mmdb::io::RFile f, int version, PMemIO memIO=NULL );
 
-    virtual void    write_mem ( PCMemIO memIO, int version );
-    virtual Boolean read_mem  ( PCMemIO memIO, int version,
-                                Boolean * Ok = NULL );
+    protected:
+
+      virtual void write_mem ( PMemIO memIO, int version );
+      virtual bool read_mem  ( PMemIO memIO, int version,
+                               bool * Ok = NULL );
+
+  };
+
+}  // namespace ccp4srs
 
-};
 
 #endif // CCP4SRS_ENTRY_H
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_index.cpp ccp4srs/ccp4srs/ccp4srs_index.cpp
--- ccp4srs-old/ccp4srs/ccp4srs_index.cpp	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_index.cpp	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_index.cpp, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_index.cpp $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,184 +22,185 @@
 //
 //  =================================================================
 //
-//    26.02.13   <--  Date of Last Modification.
+//    03.02.14   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_index  <implementation>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSIndex - SRS data index class
+//  **** Classes :  ccp4srs::Index - SRS data index class
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010-2013
+//  (C) E. Krissinel 2010-2014
 //
 //  =================================================================
 //
 
 #include <string.h>
 
-#include "mmdb/mmdb_tables.h"
-
+#include "mmdb2/mmdb_tables.h"
 #include "ccp4srs_index.h"
 
-CCP4SRSIndex::CCP4SRSIndex()  {
-  CCP4SRSIndexInit();
-}
-
-CCP4SRSIndex::~CCP4SRSIndex() {
-  if (Comp1)  delete[] Comp1;
-  if (Comp2)  delete[] Comp2;
-}
-
-void CCP4SRSIndex::CCP4SRSIndexInit ()  {
-  entryID[0] = char(0);
-  nAtoms     = 0;
-  nNonHAtoms = 0;
-  nBonds     = 0;
-  fGraphPos  = -1;
-  fStructPos = -1;
-  Comp1      = NULL;
-  Comp2      = NULL;
-}
-
-int CCP4SRSIndex::MakeCompositions ( PCCP4SRSMonomer mon )  {
-//    MakeCompositions(..) makes the compositions strings for the
-//  given structure.
-//    A composition string consists of records E(N), where E stands
-//  for chemical element name, and N - for the number of atoms of this
-//  element in the structure. The records E(N) follow in alphabetical
-//  order of E without spaces and contain no spaces, records with N=0
-//  are excluded.
-//    Comp2 differs of Comp1 only if there are leaving atoms and
-//  represents the composition with leaving atoms taken into account.
-//  If there is no leaving atoms, Comp2==Comp1.
-//    The function returns the number of leaving atoms in the.
-//  structure.
-char    Cmp1[1000];
-char    Cmp2[1000];
-char    N[50];
-ivector elem;
-int     i,k,x,l,nl;
-short   n0,n;
-
-  nAtoms = mon->n_atoms();
-  nBonds = mon->n_bonds();
-
-  strcpy ( Cmp1,"" );
-  strcpy ( Cmp2,"" );
-
-  GetVectorMemory ( elem,nAtoms,0 );
-  nNonHAtoms = 0;
-  for (i=0;i<nAtoms;i++)  {
-    elem[i] = getElementNo ( mon->atom(i)->element() );
-    if (elem[i]>1)  nNonHAtoms++;
-  }
-
-  n0 = -1;
-  n  = 0;
-  nl = 0;
-  for (i=0;(i<nAtoms) && (n<nElementNames);i++)  {
-    n = 10000;
-    for (k=0;k<nAtoms;k++)
-      if ((elem[k]>n0) && (elem[k]<n))  n = elem[k];
-    if (n<nElementNames)   {
-      x = 0;
-      l = 0;
-      for (k=0;k<nAtoms;k++)
-        if (elem[k]==n)  {
-          x++;
-          if (mon->atom(k)->leaving()=='Y')  l++;
-        }
-      nl += l;
-      sprintf ( N,"%s(%i)",ElementName[n-1],x );
-      strcat  ( Cmp1,N );
-      sprintf ( N,"%s(%i)",ElementName[n-1],x-l );
-      strcat  ( Cmp2,N );
-      n0 = n;
-    }
+namespace ccp4srs  {
+
+  Index::Index()  {
+    IndexInit();
   }
 
-  FreeVectorMemory ( elem,0 );
+  Index::~Index() {
+    if (Comp1)  delete[] Comp1;
+    if (Comp2)  delete[] Comp2;
+  }
+
+  void Index::IndexInit ()  {
+    entryID[0] = char(0);
+    nAtoms     = 0;
+    nNonHAtoms = 0;
+    nBonds     = 0;
+    fGraphPos  = -1;
+    fStructPos = -1;
+    Comp1      = NULL;
+    Comp2      = NULL;
+  }
 
-  CreateCopy ( Comp1,Cmp1 );
-  CreateCopy ( Comp2,Cmp2 );
+  int Index::MakeCompositions ( PMonomer mon )  {
+  //    MakeCompositions(..) makes the compositions strings for the
+  //  given structure.
+  //    A composition string consists of records E(N), where E stands
+  //  for chemical element name, and N - for the number of atoms of this
+  //  element in the structure. The records E(N) follow in alphabetical
+  //  order of E without spaces and contain no spaces, records with N=0
+  //  are excluded.
+  //    Comp2 differs of Comp1 only if there are leaving atoms and
+  //  represents the composition with leaving atoms taken into account.
+  //  If there is no leaving atoms, Comp2==Comp1.
+  //    The function returns the number of leaving atoms in the.
+  //  structure.
+  char          Cmp1[1000];
+  char          Cmp2[1000];
+  char          N[50];
+  mmdb::ivector elem;
+  int           i,k,x,l,nl;
+  short         n0,n;
+
+    nAtoms = mon->n_atoms();
+    nBonds = mon->n_bonds();
+
+    strcpy ( Cmp1,"" );
+    strcpy ( Cmp2,"" );
+
+    mmdb::GetVectorMemory ( elem,nAtoms,0 );
+    nNonHAtoms = 0;
+    for (i=0;i<nAtoms;i++)  {
+      elem[i] = mmdb::getElementNo ( mon->atom(i)->element() );
+      if (elem[i]>1)  nNonHAtoms++;
+    }
 
-  return nl;
+    n0 = -1;
+    n  = 0;
+    nl = 0;
+    for (i=0;(i<nAtoms) && (n<mmdb::nElementNames);i++)  {
+      n = 10000;
+      for (k=0;k<nAtoms;k++)
+        if ((elem[k]>n0) && (elem[k]<n))  n = elem[k];
+      if (n<mmdb::nElementNames)   {
+        x = 0;
+        l = 0;
+        for (k=0;k<nAtoms;k++)
+          if (elem[k]==n)  {
+            x++;
+            if (mon->atom(k)->leaving()=='Y')  l++;
+          }
+        nl += l;
+        sprintf ( N,"%s(%i)",mmdb::ElementName[n-1],x );
+        strcat  ( Cmp1,N );
+        sprintf ( N,"%s(%i)",mmdb::ElementName[n-1],x-l );
+        strcat  ( Cmp2,N );
+        n0 = n;
+      }
+    }
 
-}
+    mmdb::FreeVectorMemory ( elem,0 );
 
+    mmdb::CreateCopy ( Comp1,Cmp1 );
+    mmdb::CreateCopy ( Comp2,Cmp2 );
 
+    return nl;
 
-int CCP4SRSIndex::write ( RCFile f, int version, PCMemIO memIO ) {
-PCMemIO mem_io;
-int     rc;
+  }
 
-  if (memIO)  mem_io = memIO;
-        else  mem_io = new CMemIO();
 
-  write_mem ( mem_io,version );
-  rc = mem_io->write ( f );
 
-  if (!memIO)
-    delete mem_io;
+  int Index::write ( mmdb::io::RFile f, int version, PMemIO memIO ) {
+  PMemIO mem_io;
+  int    rc;
 
-  return rc;
+    if (memIO)  mem_io = memIO;
+          else  mem_io = new MemIO();
 
-}
+    write_mem ( mem_io,version );
+    rc = mem_io->write ( f );
 
-int CCP4SRSIndex::read ( RCFile f, int version, PCMemIO memIO )  {
-PCMemIO mem_io;
-int     rc;
+    if (!memIO)
+      delete mem_io;
 
-  if (memIO)  mem_io = memIO;
-        else  mem_io = new CMemIO();
+    return rc;
 
-  rc = mem_io->read ( f );
-  if (rc==CMemIO::Ok)  {
-    if (!read_mem(mem_io,version))
-      rc = CMemIO::MemReadError;
   }
 
-  if (!memIO)
-    delete mem_io;
-
-  return rc;
+  int Index::read ( mmdb::io::RFile f, int version, PMemIO memIO )  {
+  PMemIO mem_io;
+  int    rc;
+
+    if (memIO)  mem_io = memIO;
+          else  mem_io = new MemIO();
+
+    rc = mem_io->read ( f );
+    if (rc==MemIO::Ok)  {
+      if (!read_mem(mem_io,version))
+        rc = MemIO::MemReadError;
+    }
 
-}
+    if (!memIO)
+      delete mem_io;
 
-void CCP4SRSIndex::write_mem ( PCMemIO memIO, int version )  {
-UNUSED_ARGUMENT(version);
+    return rc;
 
-  memIO->put_line    ( entryID    );
-  memIO->put_integer ( nAtoms     );
-  memIO->put_integer ( nNonHAtoms );
-  memIO->put_integer ( nBonds     );
-  memIO->put_long    ( fGraphPos  );
-  memIO->put_long    ( fStructPos );
-  memIO->put_string  ( Comp1      );
-  memIO->put_string  ( Comp2      );
+  }
 
-}
+  void Index::write_mem ( PMemIO memIO, int version )  {
+  UNUSED_ARGUMENT(version);
 
-Boolean CCP4SRSIndex::read_mem ( PCMemIO memIO, int version,
-                                 Boolean * Ok )  {
-UNUSED_ARGUMENT(version);
-Boolean success;
+    memIO->put_line    ( entryID    );
+    memIO->put_integer ( nAtoms     );
+    memIO->put_integer ( nNonHAtoms );
+    memIO->put_integer ( nBonds     );
+    memIO->put_long    ( fGraphPos  );
+    memIO->put_long    ( fStructPos );
+    memIO->put_string  ( Comp1      );
+    memIO->put_string  ( Comp2      );
 
-  if (Ok)  success = *Ok;
-     else  success = True;
+  }
 
-  memIO->get_line    ( entryID   ,&success );
-  memIO->get_integer ( nAtoms    ,&success );
-  memIO->get_integer ( nNonHAtoms,&success );
-  memIO->get_integer ( nBonds    ,&success );
-  memIO->get_long    ( fGraphPos ,&success );
-  memIO->get_long    ( fStructPos,&success );
-  memIO->get_string  ( Comp1     ,&success );
-  memIO->get_string  ( Comp2     ,&success );
+  bool Index::read_mem ( PMemIO memIO, int version, bool * Ok )  {
+  UNUSED_ARGUMENT(version);
+  bool success;
+
+    if (Ok)  success = *Ok;
+       else  success = true;
+
+    memIO->get_line    ( entryID   ,&success );
+    memIO->get_integer ( nAtoms    ,&success );
+    memIO->get_integer ( nNonHAtoms,&success );
+    memIO->get_integer ( nBonds    ,&success );
+    memIO->get_long    ( fGraphPos ,&success );
+    memIO->get_long    ( fStructPos,&success );
+    memIO->get_string  ( Comp1     ,&success );
+    memIO->get_string  ( Comp2     ,&success );
 
-  if (Ok) *Ok = success;
-  return success;
+    if (Ok) *Ok = success;
+    return success;
 
-}
+  }
 
+}  // namespace ccp4srs
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_index.h ccp4srs/ccp4srs/ccp4srs_index.h
--- ccp4srs-old/ccp4srs/ccp4srs_index.h	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_index.h	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_index.h, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_index.h $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,13 +22,13 @@
 //
 //  =================================================================
 //
-//    26.02.13   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_index  <interface>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSIndex - SRS data index class
+//  **** Classes :  ccp4srs::Index - SRS data index class
 //       ~~~~~~~~~
 //
 //  (C) E. Krissinel 2010-2013
@@ -41,39 +41,41 @@
 
 #include "ccp4srs_monomer.h"
 
-#include "mmdb/mmdb_defs.h"
+namespace ccp4srs  {
 
-DefineClass(CCP4SRSIndex)
+  DefineClass(Index);
 
-class CCP4SRSIndex  {
+  class Index  {
 
-  public :
-    ResName  entryID;    //!< monomer or link ID
-    int      nAtoms;     //!< number of atoms in the entry
-    int      nNonHAtoms; //!< number of non-hydrogen atoms in the entry
-    int      nBonds;     //!< number of bonds in the entry
-    long     fGraphPos;  //!< file offset for CGraph
-    long     fStructPos; //!< file offset for CCP4SRSMonomer
-    pstr     Comp1;      //!< composition string
-    pstr     Comp2;      //!< composition string with leaving atom
+    public :
+      mmdb::ResName entryID;    //!< monomer or link ID
+      int           nAtoms;     //!< number of atoms in the entry
+      int           nNonHAtoms; //!< number of non-hydrogen atoms in the entry
+      int           nBonds;     //!< number of bonds in the entry
+      long          fGraphPos;  //!< file offset for CGraph
+      long          fStructPos; //!< file offset for CCP4SRSMonomer
+      mmdb::pstr    Comp1;      //!< composition string
+      mmdb::pstr    Comp2;      //!< composition string with leaving atom
 
-    CCP4SRSIndex ();
-    virtual ~CCP4SRSIndex();
+      Index ();
+      virtual ~Index();
 
-    int   MakeCompositions ( PCCP4SRSMonomer monomer );
+      int   MakeCompositions ( PMonomer monomer );
 
-    int write ( RCFile f, int version, PCMemIO memIO=NULL );
-    int read  ( RCFile f, int version, PCMemIO memIO=NULL );
+      int write ( mmdb::io::RFile f, int version, PMemIO memIO=NULL );
+      int read  ( mmdb::io::RFile f, int version, PMemIO memIO=NULL );
 
-  protected:
+    protected:
 
-    void  CCP4SRSIndexInit();
+      void  IndexInit();
 
-    virtual void    write_mem ( PCMemIO memIO, int version );
-    virtual Boolean read_mem  ( PCMemIO memIO, int version,
-                                Boolean * Ok = NULL );
+      virtual void write_mem ( PMemIO memIO, int version );
+      virtual bool read_mem  ( PMemIO memIO, int version,
+                               bool * Ok = NULL );
 
-};
+  };
+
+}  // namespace ccp4srs
 
 
 #endif // CCP4SRS_INDEX_H
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_manager.cpp ccp4srs/ccp4srs/ccp4srs_manager.cpp
--- ccp4srs-old/ccp4srs/ccp4srs_manager.cpp	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_manager.cpp	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_manager.cpp, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_manager.cpp $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,13 +22,13 @@
 //
 //  =================================================================
 //
-//    26.02.13   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_manager  <implementation>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSManager - SRS general manager class
+//  **** Classes :  ccp4srs::Manager - SRS general manager class
 //       ~~~~~~~~~
 //
 //  (C) E. Krissinel 2010-2013
@@ -36,12 +36,15 @@
 //  =================================================================
 //
 
-#ifndef  __STRING_H
 #include <string.h>
-#endif
 
 #include "ccp4srs_manager.h"
 
-CCP4SRSManager::CCP4SRSManager() : CCP4SRSChem()  {}
+namespace ccp4srs  {
+
+  Manager::Manager() : Chem()  {}
+
+  Manager::~Manager()  {}
+
+}  // namespace ccp4srs
 
-CCP4SRSManager::~CCP4SRSManager()  {}
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_manager.h ccp4srs/ccp4srs/ccp4srs_manager.h
--- ccp4srs-old/ccp4srs/ccp4srs_manager.h	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_manager.h	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_manager.h, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_manager.h $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,13 +22,13 @@
 //
 //  =================================================================
 //
-//    26.02.13   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_manager  <interface>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSManager - SRS general manager class
+//  **** Classes :  ccp4srs::Manager - SRS general manager class
 //       ~~~~~~~~~
 //
 //  (C) E. Krissinel 2010-2013
@@ -41,17 +41,20 @@
 
 #include "ccp4srs_chem.h"
 
+namespace ccp4srs  {
 
-// ==================================================================
+  // ==================================================================
 
-DefineClass(CCP4SRSManager);
+  DefineClass(Manager);
 
-class CCP4SRSManager : public CCP4SRSChem {
+  class Manager : public Chem {
 
-  public:
-    CCP4SRSManager ();
-    ~CCP4SRSManager();
+    public:
+      Manager ();
+      ~Manager();
 
-};
+  };
+
+}  // namespace ccp4srs
 
 #endif // CCP4SRS_MANAGER_H
